/*******************************************************************************
 * Copyright (c) 2004, 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.wst.xml.ui.internal.tabletree;

import org.eclipse.wst.xml.ui.internal.XMLUIPlugin;



/**
 * Help context ids for the TableTree view.
 * <p>
 * This interface contains constants only; it is not intended to be
 * implemented or extended.
 * </p>
 * 
 */
public interface XMLTableTreeHelpContextIds {
	// org.eclipse.wst.xml.ui.
	public static final String PREFIX = XMLUIPlugin.ID + "."; //$NON-NLS-1$

	// XML Design View
	public static final String XML_DESIGN_VIEW_HELPID = PREFIX + "xmlm3000"; //$NON-NLS-1$
}
